



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[LeetCode] Merge Intervals 合并区间</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[LeetCode] Merge Intervals 合并区间</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 14:09:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Given a collection of intervals, merge all overlapping intervals.</p>
<p>Example 1:</p>
<pre class="prettyprint linenums">Input: [[1,3],[2,6],[8,10],[15,18]]<br />
Output: [[1,6],[8,10],[15,18]]<br />
Explanation: Since intervals [1,3] and [2,6] overlaps, merge them into [1,6].
</pre>
<p>Example 2:</p>
<pre class="prettyprint linenums">Input: [[1,4],[4,5]]<br />
Output: [[1,5]]<br />
Explanation: Intervals [1,4] and [4,5] are considered overlapping.</pre>
<p>NOTE:&nbsp;input types have been changed on April 15, 2019. Please reset to default code definition to get new method signature.</p>
<p>这道和之前那道&nbsp;<a href="http://www.cnblogs.com/grandyang/p/4367569.html" rel="external nofollow noreferrer">Insert Interval</a>&nbsp;很类似，这次题目要求我们合并区间，之前那题明确了输入区间集是有序的，而这题没有，所以我们首先要做的就是给区间集排序，由于我们要排序的是个结构体，所以我们要定义自己的 comparator，才能用 sort 来排序，我们以 start 的值从小到大来排序，排完序我们就可以开始合并了，首先把第一个区间存入结果中，然后从第二个开始遍历区间集，如果结果中最后一个区间和遍历的当前区间无重叠，直接将当前区间存入结果中，如果有重叠，将结果中最后一个区间的 end 值更新为结果中最后一个区间的 end 和当前 end 值之中的较大值，然后继续遍历区间集，以此类推可以得到最终结果，代码如下：</p>
<p>解法一:</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    vector&lt;vector&lt;int&gt;&gt; merge(vector&lt;vector&lt;int&gt;&gt;&amp; intervals) {<br />
        if (intervals.empty()) return {};<br />
        sort(intervals.begin(), intervals.end());<br />
        vector&lt;vector&lt;int&gt;&gt; res{intervals[]};<br />
        for (int i = ; i &lt; intervals.size(); ++i) {<br />
            if (res.back()[] &lt; intervals[i][]) {<br />
                res.push_back(intervals[i]);<br />
            } else {<br />
                res.back()[] = max(res.back()[], intervals[i][]);<br />
            }<br />
        }<br />
        return res;<br />
    }<br />
};</pre>
</div>
<p>下面这种解法将起始位置和结束位置分别存到了两个不同的数组 starts 和 ends 中，然后分别进行排序，之后用两个指针i和j，初始化时分别指向 starts 和 ends 数组的首位置，然后如果i指向 starts 数组中的最后一个位置，或者当 starts 数组上 i+1 位置上的数字大于 ends 数组的i位置上的数时，此时说明区间已经不连续了，我们来看题目中的例子，排序后的 starts 和 ends 为：</p>
<p>starts:&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; 8&nbsp;&nbsp;&nbsp; 15</p>
<p>ends:&nbsp;&nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; &nbsp;&nbsp;&nbsp; 10&nbsp;&nbsp;&nbsp; 18</p>
<p>红色为i的位置，蓝色为j的位置，那么此时 starts[i+1] 为8，ends[i] 为6，8大于6，所以此时不连续了，将区间 [starts[j], ends[i]]，即 [1, 6] 加入结果 res 中，然后j赋值为 i+1 继续循环，参见代码如下：</p>
<p>解法二：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    vector&lt;vector&lt;int&gt;&gt; merge(vector&lt;vector&lt;int&gt;&gt;&amp; intervals) {<br />
        int n = intervals.size();<br />
        vector&lt;vector&lt;int&gt;&gt; res;<br />
        vector&lt;int&gt; starts, ends;<br />
        for (int i = ; i &lt; n; ++i) {<br />
            starts.push_back(intervals[i][]);<br />
            ends.push_back(intervals[i][]);<br />
        }<br />
        sort(starts.begin(), starts.end());<br />
        sort(ends.begin(), ends.end());<br />
        for (int i = , j = ; i &lt; n; ++i) {<br />
            if (i == n -  || starts[i + ] &gt; ends[i]) {<br />
                res.push_back({starts[j], ends[i]});<br />
                j = i + ;<br />
            }<br />
        }<br />
        return res;<br />
    }<br />
};</pre>
</div>
<p>这道题还有另一种解法，这个解法直接调用了之前那道题&nbsp;<a href="http://www.cnblogs.com/grandyang/p/4367569.html" rel="external nofollow noreferrer">Insert Interval</a>&nbsp;的函数，由于插入的过程中也有合并的操作，所以我们可以建立一个空的集合，然后把区间集的每一个区间当做一个新的区间插入结果中，也可以得到合并后的结果，那道题中的四种解法都可以在这里使用，但是没必要都列出来，这里只选了那道题中的解法二放到这里，代码如下：</p>
<p>解法三：</p>
<div>
<pre class="prettyprint linenums">class Solution {<br />
public:<br />
    vector&lt;vector&lt;int&gt;&gt; merge(vector&lt;vector&lt;int&gt;&gt;&amp; intervals) {<br />
        vector&lt;vector&lt;int&gt;&gt; res;<br />
        for (int i = ; i &lt; intervals.size(); ++i) {<br />
            res = insert(res, intervals[i]);<br />
        }<br />
        return res;<br />
    }<br />
    vector&lt;vector&lt;int&gt;&gt; insert(vector&lt;vector&lt;int&gt;&gt;&amp; intervals, vector&lt;int&gt; newInterval) {<br />
        vector&lt;vector&lt;int&gt;&gt; res;<br />
        int n = intervals.size(), cur = ;<br />
        for (int i = ; i &lt; n; ++i) {<br />
            if (intervals[i][] &lt; newInterval[]) {<br />
                res.push_back(intervals[i]);<br />
                ++cur;<br />
            } else if (intervals[i][] &gt; newInterval[]) {<br />
                res.push_back(intervals[i]);<br />
            } else {<br />
                newInterval[] = min(newInterval[], intervals[i][]);<br />
                newInterval[] = max(newInterval[], intervals[i][]);<br />
            }<br />
        }<br />
        res.insert(res.begin() + cur, newInterval);<br />
        return res;<br />
    }<br />
};</pre>
</div>
<p>Github 同步地址：</p>
<p><a href="https://github.com/grandyang/leetcode/issues/56" rel="external nofollow noreferrer">https://github.com/grandyang/leetcode/issues/56</a></p>
<p>类似题目：</p>
<p><a href="http://www.cnblogs.com/grandyang/p/8552586.html" rel="external nofollow noreferrer">Employee Free Time</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/4367569.html" rel="external nofollow noreferrer">Insert Interval</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/5244720.html" rel="external nofollow noreferrer">Meeting Rooms II</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/5240774.html" rel="external nofollow noreferrer">Meeting Rooms</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/6399408.html" rel="external nofollow noreferrer">Teemo Attacking</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/7043394.html" rel="external nofollow noreferrer">Add Bold Tag in String</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/8586531.html" rel="external nofollow noreferrer">Range Module</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/8654822.html" rel="external nofollow noreferrer">Partition Labels</a></p>
<p>Interval List Intersections</p>
<p>参考资料：</p>
<p><a href="https://leetcode.com/problems/merge-intervals/" rel="external nofollow noreferrer">https://leetcode.com/problems/merge-intervals/</a></p>
<p><a href="https://leetcode.com/problems/merge-intervals/discuss/21242/C++-10-line-solution.-easing-understanding" rel="external nofollow noreferrer">https://leetcode.com/problems/merge-intervals/discuss/21242/C++-10-line-solution.-easing-understanding</a></p>
<p><a href="https://leetcode.com/problems/merge-intervals/discuss/21223/Beat-98-Java.-Sort-start-and-end-respectively." rel="external nofollow noreferrer">https://leetcode.com/problems/merge-intervals/discuss/21223/Beat-98-Java.-Sort-start-and-end-respectively</a></p>
<p><a href="http://www.cnblogs.com/grandyang/p/4606334.html" rel="external nofollow noreferrer">LeetCode All in One 题目讲解汇总(持续更新中...)</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlkpy08.html">PHP Date&lpar;&rpar;函数详细参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw30k8.html">每周一书-编写高质量代码：改善C程序代码的125个建议</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o6nv58.html">&lpar;转&rpar;无法将类型为&OpenCurlyDoubleQuote;Microsoft&period;Office&period;Interop&period;Word&period;ApplicationClass&rdquo;的 COM 对象强制转换为接口类型&OpenCurlyDoubleQuote;Microsoft&period;Office&period;Interop&period;Word&period;&lowbar;Application&rdquo;。此操作失败的原因是对 IID 为&OpenCurlyDoubleQuote;&lbrace;00020970-</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96x0py9.html">esc安装数据库  sqlserver mssql</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde04gx9.html">JAVA基础知识之JVM-&mdash;&mdash;自定义类加载器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zr5m29.html">【linux】chmod命令详细用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgoe1q.html">多路选择器（multiplexer）简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x17jr9.html">web项目学习之sitemesh</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zj2rj9.html">关于readonly</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjn7338.html">C&sol;C&plus;&plus;的静态库与动态库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy74x8.html">Python测试开发之---string</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ko2k69.html">VMware-vCenter-Server-Appliance VCSA升级步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3oy19.html">Java-HttpSession监听</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m6klm8.html">在无向图中找最短桥&lpar;tarjan&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1mp3jq.html">jquery中数组对象下面的属性名名是动态的如何获取</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rmk158.html">HBase Filter及对应Shell</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o22ze8.html">xpath提取到的中文乱码时的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1eepxq.html">spring 自己定义标签 学习二</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjldze9.html">php 制作验证码不显示的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj5x7jq.html">kafka 的quick start&lpar;windows平台&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rqlrokqo.html">ASP&period;NET Core 中文文档 第二章 指南（4&period;5）使用 SQL Server LocalDB</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdydzqd.html">ASP&period;NET Core 中文文档 第三章 原理（17）为你的服务器选择合适版本的&period;NET框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq13pz8g.html">WCF学习系列汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7k79j.html">Linux下的解压命令小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93mxg83.html">c&num;面向对象基础技能&mdash;&mdash;学习笔记（五）委托技术在开发中的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rvem80.html">C&num; 引用类型和值类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1e259g.html">PHP 装饰器模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q74reqe.html">用jmeter通过ssl验证访问https</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7mxzgq.html">CSS3鼠标滑过动画线条边框特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mney2q.html">自定义PopupWindow</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
